def p1():
  #DataFrame
  ## ## 1. Create a data frame “df_emp” with a minimum of 10 records of employee displaying employee id, employee name, salary, designation.
  code='''
  import pandas as pd

  # Create df_emp
  data_emp = {
      'Employee ID': [101, 102, 103, 104, 105, 106, 107, 108, 109, 110],
      'Employee Name': ['Alice', 'Bob', 'Charlie', 'David', 'Eva', 'Frank', 'Grace', 'Henry', 'Ivy', 'Jack'],
      'Salary': [50000, 75000, 60000, 45000, 80000, 55000, 90000, 65000, 70000, 48000],
      'Designation': ['Manager', 'Developer', 'Analyst', 'Intern', 'CEO', 'Developer', 'Manager', 'Analyst', 'Developer', 'Intern']
  }

  df_emp = pd.DataFrame(data_emp)

  # Display descriptive statistics for Salary
  print("Descriptive Statistics for Salary:")
  print(df_emp['Salary'].describe())

  # Create df_account
  data_account = {
      'AcNo': ['A00023', 'A00121', 'A00234', 'A01208', 'A01208', 'A00789', 'A00893', 'A00987'],
      'CustID': ['C02', 'C01', 'C02', 'C06', 'C01', 'C04', 'C05', 'C03'],
      'Type': ['Savings', 'Current', 'Current', 'Current', 'Current', 'Savings', 'Savings', 'Current'],
      'Branch': ['B04', 'B01', 'B04', 'B02', 'B02', 'B04', 'B06', 'B02'],
      'Balance': [90000, 80567, 12000, 45000, 45000, 4500, 67900, 78600]
  }

  df_account = pd.DataFrame(data_account)

  # ii. Print second and third columns:
  print(df_account.iloc[:, 1:3])  # Columns 1 (CustID) and 2 (Type)

  # iii. Print 4th to 7th rows:
  print(df_account.iloc[3:7])  # Rows with indices 3, 4, 5, 6

  # iv. Print column names:
  print(df_account.columns.tolist())

  # v. Records where balance is between 30k to 40k:
  # No records match this condition in the provided data
  print(df_account[(df_account['Balance'] >= 30000) & (df_account['Balance'] <= 40000)])

  # vi. Savings accounts in Branch B04:
  print(df_account[(df_account['Type'] == 'Savings') & (df_account['Branch'] == 'B04')])

  # vii. Average balance branch-wise:
  print(df_account.groupby('Branch')['Balance'].mean())

  # viii. Bar plot for accounts per branch:
  import matplotlib.pyplot as plt
  df_account['Branch'].value_counts().plot(kind='bar')
  plt.title('Accounts per Branch')
  plt.xlabel('Branch')
  plt.ylabel('Count')
  plt.show()


  #1. Create df_cust with Sample Data:
  import pandas as pd

  # Create df_cust with sample data
  data_cust = {
      'CustID': ['C01', 'C02', 'C03', 'C04', 'C05', 'C06', 'C07', 'C08', 'C09', 'C10'],
      'Education': [2, 1, 3, 2, 2, 1, 3, 2, 1, 3],
      'Age': [35, 28, 40, 32, 29, 45, 38, 27, 31, 36],
      'Balance': [95000, 45000, 120000, 67000, 88000, 55000, 150000, 72000, 48000, 135000]
  }

  df_cust = pd.DataFrame(data_cust)

  # ii. Print second to fourth columns:
  print("\nSecond to fourth columns:")
  print(df_cust.iloc[:, 1:4])  # Columns: Education, Age, Balance


  # iii. Print 3rd and 5th rows
  print("\n3rd and 5th rows:")
  print(df_cust.iloc[[2, 4]])  # Rows at index 2 (3rd row) and 4 (5th row)


  # iv. Print column names:
  print("\nColumn names:")
  print(df_cust.columns.tolist())

  # v. Records where balance > 90,000:
  print("\nBalance > 90,000:")
  print(df_cust[df_cust['Balance'] > 90000])

  # vi. Records where Education type is 2:
  print("\nEducation type = 2:")
  print(df_cust[df_cust['Education'] == 2])

  # vii. Average balance as per age:
  print("\nAverage balance by age:")
  print(df_cust.groupby('Age')['Balance'].mean())

  # viii. Maximum balance as per education type:
  print("\nMaximum balance by education:")
  print(df_cust.groupby('Education')['Balance'].max())
'''
  print(code)





def p2():
  code = '''
import pandas as pd

# Assuming the dataset is loaded into a DataFrame named df
df = pd.read_csv('Comcast.csv')

# 1. Print the number of records and number of columns
num_records, num_columns = df.shape
print(f"Number of records: {num_records}")
print(f"Number of columns: {num_columns}")

# 2. Separate the numerical and categorical data types
numerical_columns = df.select_dtypes(include=['number']).columns
categorical_columns = df.select_dtypes(include=['object']).columns
print("Numerical columns:", numerical_columns)
print("Categorical columns:", categorical_columns)

# 3. Print the number of complaints as per the type of status
status_counts = df['Status'].value_counts()
print("Number of complaints by status:")
print(status_counts)

# 4. Print the records of the complaints received via "Internet"
internet_complaints = df[df['Received Via'] == 'Internet']
print("Complaints received via Internet:")
print(internet_complaints)

# 5. Print the name of the state which received the maximum number of complaints
max_complaints_state = df['State'].value_counts().idxmax()
print("State with maximum complaints:", max_complaints_state)

# 6. Print the records of the customers from the city "Atlanta" where complaints are received via "Customer Care Call"
atlanta_customer_care = df[(df['City'] == 'Atlanta') & (df['Received Via'] == 'Customer Care Call')]
print("Complaints from Atlanta via Customer Care Call:")
print(atlanta_customer_care)

# 7. Drop the Ticket# (column)
df = df.drop(columns=['Ticket #'])

# 8. Print the number of open and closed complaints as per the "Zipcode"
zip_status_counts = df.groupby(['Zip code', 'Status']).size().unstack(fill_value=0)
print("Open and closed complaints by Zipcode:")
print(zip_status_counts)

# 9. Print the names of the columns
print("Column names:")
print(df.columns.tolist())

# 10. Print the second and third columns
second_third_columns = df.iloc[:, 1:3]
print("Second and third columns:")
print(second_third_columns)
'''
  print(code)



def p3():
  code = '''
import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns

# Load the dataset
df = pd.read_excel('online_retail.xlsx')

# i. Print the number of rows and columns
num_rows, num_columns = df.shape
print(f"Number of rows: {num_rows}")
print(f"Number of columns: {num_columns}")

# ii. Print the column names
print("\nColumn names:")
print(df.columns.tolist())

# iii. Print the data types
print("\nData types:")
print(df.dtypes)

# iv. Print InvoiceNo and count of products per invoice
invoice_product_count = df.groupby('Invoice')['Description'].count().reset_index()
invoice_product_count.columns = ['Invoice', 'ProductCount']
print("\nInvoiceNo and count of products per invoice:")
print(invoice_product_count)

# v. Print CustomerID and average UnitPrice
customer_avg_price = df.groupby('Customer ID')['Price'].mean().reset_index()
customer_avg_price.columns = ['Customer ID', 'AverageUnitPrice']
print("\nCustomerID and average Price:")
print(customer_avg_price)

# vi. Print Description and InvoiceDate of products sold in the United Kingdom or Denmark
uk_denmark_sales = df[df['Country'].isin(['United Kingdom', 'Denmark'])]
print("\nDescription and InvoiceDate of products sold in the United Kingdom or Denmark:")
print(uk_denmark_sales[['Description', 'InvoiceDate']])

# vii. Perform univariate analysis on the UnitPrice
print("\nUnivariate analysis of UnitPrice:")
print(df['Price'].describe())

# viii. Calculate outliers with statistics for the UnitPrice column
Q1 = df['Price'].quantile(0.25)
Q3 = df['Price'].quantile(0.75)
IQR = Q3 - Q1
lower_bound = Q1 - 1.5 * IQR
upper_bound = Q3 + 1.5 * IQR
outliers = df[(df['Price'] < lower_bound) | (df['Price'] > upper_bound)]
print("\nOutliers in Price:")
print(f"Lower bound: {lower_bound}, Upper bound: {upper_bound}")
print(f"Number of outliers: {len(outliers)}")

# ix. Print the records of products which are outliers as per their UnitPrice
print("\nRecords of products with outlier Price:")
print(outliers)

# xi. Plot a boxplot for the Quantity column
plt.figure(figsize=(8, 6))
sns.boxplot(df['Quantity'])
plt.title("Boxplot of Quantity")
plt.show()
'''
  print(code)


def p4():
  codes='''
  import pandas as pd
import seaborn as sns
import matplotlib.pyplot as plt


df = pd.read_csv('/content/diabetes.csv')
print("\n1. Correlation Matrix and BMI Inferences:")
corr_matrix = df.corr()
print("\nCorrelation Matrix:")
print(corr_matrix)

print("\nBMI Correlations:")
print(corr_matrix['BMI'].sort_values(ascending=False))
print("\nBMI Inferences:")
print("""- SkinThickness shows strongest positive correlation with BMI
- Insulin and Age have moderate positive correlation
- BloodPressure has weak positive correlation
- No significant correlation with Glucose or DiabetesPedigreeFunction""")

# 2. Number of diabetic patients
print("\n2. Diabetic Patients Count:")
diabetic_count = df['Outcome'].sum()
print(f"Number of diabetic patients: {diabetic_count}")

# 3. Patients with BMI 35-40
print("\n3. Patients with BMI 35-40:")
bmi_35_40 = df[(df['BMI'] >= 35) & (df['BMI'] <= 40)]
print(bmi_35_40)

# 4. High BloodPressure records
print("\n4. Patients with BloodPressure > 100:")
high_bp = df[df['BloodPressure'] > 100][['BloodPressure', 'BMI', 'Outcome']]
print(high_bp)

# 5. Age univariate analysis
print("\n5. Age Analysis Visualizations:")
plt.figure(figsize=(15, 5))

plt.subplot(1, 3, 1)
sns.histplot(df['Age'], kde=False, bins=20)
plt.title('Age Histogram')

plt.subplot(1, 3, 2)
sns.kdeplot(df['Age'])
plt.title('Age KDE Plot')

plt.subplot(1, 3, 3)
sns.boxplot(x=df['Age'])
plt.title('Age Boxplot')

plt.tight_layout()
plt.show()
print("\nAge Analysis Inferences:")
print("""- Right-skewed distribution with most patients <40
- Several outliers in older age groups (>60)
- Median age around 29 years""")

# 6. BMI outliers analysis
print("\n6. BMI Outliers Analysis:")
Q1 = df['BMI'].quantile(0.25)
Q3 = df['BMI'].quantile(0.75)
IQR = Q3 - Q1
lower_bound = Q1 - 1.5*IQR
upper_bound = Q3 + 1.5*IQR

outliers = df[(df['BMI'] < lower_bound) | (df['BMI'] > upper_bound)]
print(f"Number of BMI outliers: {len(outliers)}")

plt.figure(figsize=(6, 4))
sns.boxplot(x=df['BMI'])
plt.title('BMI Boxplot')
plt.show()

# 7. Pregnancies by diabetic status
print("\n7. Pregnancies Distribution by Diabetic Status:")
plt.figure(figsize=(12, 6))
preg_counts = df.groupby(['Outcome', 'Pregnancies']).size().unstack()
preg_counts.plot(kind='bar', stacked=True)
plt.title('Pregnancies Count by Diabetic Status')
plt.xlabel('Number of Pregnancies')
plt.ylabel('Count')
plt.legend(title='Diabetes Status', labels=['Non-Diabetic', 'Diabetic'])
plt.show()

# 8. Glucose vs DiabetesPedigreeFunction and combined filter
print("\n8. Glucose vs Diabetes Pedigree Function:")
plt.figure(figsize=(8, 5))
plt.scatter(df['Glucose'], df['DiabetesPedigreeFunction'], alpha=0.5)
plt.xlabel('Glucose')
plt.ylabel('Diabetes Pedigree Function')
plt.title('Glucose vs Diabetes Pedigree Function')
plt.show()

print("\nPatients with Diabetes or Glucose > 150:")
combined_filter = df[(df['Outcome'] == 1) | (df['Glucose'] > 150)]
print(combined_filter)
  '''
  print(codes)



def p5():
  codes='''import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns

df = pd.read_csv('//content/Practical 6_CarPrice_Assignment.csv')
print(df.head())

# 1. Drop car_ID
df.drop('car_ID', axis=1, inplace=True)

# 2. Count by doornumber
print("2. Car count by door number:")
print(df['doornumber'].value_counts())

# 3. Filter cars with carlength 100-150
print("\n3. Cars with carlength 100-150:")
print(df.loc[(df['carlength'] >= 100) & (df['carlength'] <= 150), ['citympg', 'carlength', 'price']])

# 4. Cars with 4 or 6 cylinders
print("\n4. Cars with 4 or 6 cylinders:")
print(df[df['cylindernumber'].isin(['four', 'six'])])

# 5. Split into numeric and categorical dataframes
numdf = df.select_dtypes(include=['number'])
catdf = df.select_dtypes(exclude=['number'])
print("\n5. Numeric dataframe shape:", numdf.shape)
print("Categorical dataframe shape:", catdf.shape)

# 6. Correlation matrix
print("\n6. Correlation matrix:")
print(numdf.corr())

# 7. Visualize carlength vs citympg
plt.figure(figsize=(8, 5))
sns.scatterplot(x='carlength', y='citympg', data=df)
plt.title('Car Length vs City MPG')
plt.show()
print("\n7. Inference: Longer cars generally show lower city MPG values, indicating an inverse relationship between size and fuel efficiency.")

# 8. Calculate price outliers
Q1 = df['price'].quantile(0.25)
Q3 = df['price'].quantile(0.75)
IQR = Q3 - Q1
bounds = (Q1 - 1.5*IQR, Q3 + 1.5*IQR)
print("\n8. Price outlier bounds:", bounds)

# 9. Filter price outliers
outliers = df[(df['price'] < bounds[0]) | (df['price'] > bounds[1])]
print("\n9. Price outliers:")
print(outliers)

# 10. Average price by engine type
plt.figure(figsize=(10, 6))
df.groupby('enginetype')['price'].mean().plot(kind='bar', color=['skyblue', 'salmon', 'lightgreen'])
plt.title('Average Price by Engine Type')
plt.ylabel('Price')
plt.show()'''

  print(codes)




def p6():
  codes=''' import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns
df = pd.read_csv('/content/Practical_5_Boston (1).csv')
print(df.head())

# 1. Print records where medv is between 10 and 15
print("1. Records with medv between 10 and 15 k dollars:")
print(df[(df['medv'] >= 10) & (df['medv'] <= 15)])

# 2. Print medv and crim for properties on Charles River
print("\n2. Price and crime rate for riverside properties:")
print(df[df['chas'] == 1][['medv', 'crim']])

# 3. Print correlation matrix
print("\n3. Correlation matrix:")
print(df.corr())

# 4. Print data types
print("\n4. Data types:")
print(df.dtypes)

# 5. Average price by chas
print("\n5. Average price by chas:")
print(df.groupby('chas')['medv'].mean())

# 6. Histogram and KDE plots for lstat and crim
plt.figure(figsize=(12, 5))
plt.subplot(1, 2, 1)
sns.histplot(df['lstat'], kde=True)
plt.title('LSTAT Distribution')

plt.subplot(1, 2, 2)
sns.histplot(df['crim'], kde=True)
plt.title('CRIM Distribution')
plt.tight_layout()
plt.show()

print("\n6. Inferences:")
print("LSTAT: Right-skewed, most values <20% lower status population.")
print("CRIM: Highly right-skewed, majority of areas have low crime rates with few extreme outliers.")

# 7. Boxplot for nox
plt.figure()
sns.boxplot(x=df['nox'])
plt.title('NOX Boxplot')
plt.show()

# 8. Outliers in medv
Q1 = df['medv'].quantile(0.25)
Q3 = df['medv'].quantile(0.75)
IQR = Q3 - Q1
lower_bound = Q1 - 1.5 * IQR
upper_bound = Q3 + 1.5 * IQR
outliers = df[(df['medv'] < lower_bound) | (df['medv'] > upper_bound)]
print("\n8. Outliers in medv:")
print(outliers)

# 9. Average crime rate by radial highways
print("\n9. Average crime rate by radial highways:")
print(df.groupby('rad')['crim'].mean())

# Descriptive statistics for indus
print("\nDescriptive statistics for INDUS:")
print(df['indus'].describe())'''

  print(codes)





def sheet_2():
  code = '''
### 1. Compare 3 numbers and print the largest one using logical operators
```python
a, b, c = map(int, input("Enter three numbers separated by spaces: ").split())
if a >= b and a >= c:
    print("Largest number is:", a)
elif b >= a and b >= c:
    print("Largest number is:", b)
else:
    print("Largest number is:", c)
```

---

### 2. Function to accept a number and print the factorial
```python
def factorial(n):
    fact = 1
    for i in range(1, n + 1):
        fact *= i
    return fact

num = int(input("Enter a number: "))
print("Factorial is:", factorial(num))
```

---

### 3. Accept inputs and perform 5 arithmetic operations
```python
a, b = map(int, input("Enter two numbers separated by spaces: ").split())
print("Addition:", a + b)
print("Subtraction:", a - b)
print("Multiplication:", a * b)
print("Division:", a / b)
print("Modulus:", a % b)
```

---

### 4. Print the sum of digits of a number
```python
num = int(input("Enter a number: "))
print("Sum of digits:", sum(int(digit) for digit in str(num)))
```

---

### 5. Calculate distance between two points using a lambda function
```python
import math
distance = lambda x1, y1, x2, y2: math.sqrt((x2 - x1)**2 + (y2 - y1)**2)
x1, y1 = map(int, input("Enter x1 and y1: ").split())
x2, y2 = map(int, input("Enter x2 and y2: ").split())
print("Distance:", distance(x1, y1, x2, y2))
```

---

### 6. Check if a number is even using a while loop
```python
num = int(input("Enter a number: "))
while num % 2 == 0:
    print("The number is even.")
    break
else:
    print("The number is odd.")
```

---

### 7. `dynsum()` function to accept a dynamic list of numbers and calculate their sum
```python
def dynsum(*numbers):
    return sum(numbers)

nums = map(int, input("Enter numbers separated by spaces: ").split())
print("Sum of numbers:", dynsum(*nums))
```

---

### 8. Perform set operations
```python
A = {1, 2, 3, 4, 5}
B = {4, 5, 6, 7, 8}

print("Union:", A | B)
print("Intersection:", A & B)
print("Difference (A - B):", A - B)
print("Difference (B - A):", B - A)
print("Symmetric Difference:", A ^ B)
```

---

### 9. Accept 10 numbers and print the average
```python
nums = [int(input(f"Enter number {i + 1}: ")) for i in range(10)]
print("Average:", sum(nums) / len(nums))
```

---

### 10. Check if a number is even or odd using a lambda function
```python
is_even = lambda x: "Even" if x % 2 == 0 else "Odd"
num = int(input("Enter a number: "))
print(is_even(num))
```
'''
  print(code)

